from odoo import _
from odoo.addons.saas_worker.compat import route, http, request
from odoo.exceptions import UserError

from odoo.tools.parse_version import parse_version


class LoempiaEmbedController(http.Controller):
    @route('/apps/embed/client', auth='public')
    def client(self, **kw):
        return request.render('loempia.embed_client', {})

    @route('/apps/embed/update', type='json', auth='public')
    def update(self, **kw):
        user_serie = kw.get('version', {}).get('server_serie', '10.0')
        user_module = kw.get('modules', {})
        loempia_serie = request.env['loempia.series'].search([('name', '=', user_serie)], limit=1)
        loempia_module = request.env['loempia.module'].search([('series_id', '=', loempia_serie.id), ('name', 'in', list(kw.get('modules', {}).keys()))])

        mod_to_update = {}
        for module in loempia_module:
            # attention: Incorrect field names !!
            #   installed_version refer the latest version (the one on disk)
            #   latest_version refer the installed version (the one in database)
            if parse_version(module.version) > parse_version(user_module[module.name].get('latest_version')):
                mod_to_update[module.name] = {
                    'id': module.id,
                    'name': module.name,
                    'version_local_running': user_module[module.name].get('latest_version'),
                    'version_local_downloaded': user_module[module.name].get('installed_version'),
                    'version_remote': module.version,
                    'changelog': module.changelog_html,
                }
                if parse_version(module.version) > parse_version(user_module[module.name].get('installed_version')):
                    mod_to_update[module.name]['todo'] = 'to_download'
                else:
                    mod_to_update[module.name]['todo'] = 'to_update'
        return mod_to_update
